1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132
|
#!/bin/sh
# Copyright (C) 2022-2025 Simon Josefsson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
srcdir="${srcdir:-.}"
IDN2="${IDN2:-../src/idn2$EXEEXT}"
TMPFILE="idn2.$$.tmp"
trap 'rm -f "$TMPFILE" "$TMPFILE-2"' EXIT QUIT
if ! test -z "${LOG_VALGRIND}";then
LOG_VALGRIND="${LIBTOOL:-libtool} --mode=execute ${LOG_VALGRIND} --error-exitcode=7"
fi
# Sanity check, does it run at all?
$IDN2 --version
rc=$?
if test $rc != 0; then
echo "FAIL: $0: $IDN2 --version: rc $rc"
exit 1
fi
# Check that we can work under valgrind:
$LOG_VALGRIND $IDN2 --version
rc=$?
if test $rc != 0; then
echo "FAIL: $0: valgrind $IDN2 --version: rc $rc"
exit 1
fi
# Code coverage trigger:
$LOG_VALGRIND $IDN2 --help
rc=$?
if test $rc != 0; then
echo "FAIL: $0: valgrind $IDN2 --help: rc $rc"
exit 1
fi
# Actually convert something, even though it is the empty string.
# Mostly to catch locale/iconv-related issues.
$LOG_VALGRIND $IDN2 ''
rc=$?
if test $rc != 0; then
echo "FAIL: $0: $IDN2 '': rc $rc"
exit $rc
fi
echo "PASS: $0: $IDN2 ''"
# Does it handle a simple ASCII string on the command-line?
$LOG_VALGRIND $IDN2 example.org > $TMPFILE 2> $TMPFILE-2
rc=$?
OUTSTR="$(cat $TMPFILE | tr -d '\r')"
ERRSTR="$(cat $TMPFILE-2)"
if test $rc != 0; then
echo "FAIL: $0: $IDN2 example.org: rc $rc"
echo "OUT: $OUTSTR"
echo "ERR: $ERRSTR"
exit 1
fi
if test "$OUTSTR" != example.org; then
echo "FAIL: $0: $IDN2 example.org: expected example.org got $OUTSTR"
echo "OUT: $OUTSTR"
echo "ERR: $ERRSTR"
exit 1
fi
if test "$ERRSTR" != ""; then
echo "FAIL: $0: $IDN2 example.org: stderr: $ERRSTR"
echo "OUT: $OUTSTR"
echo "ERR: $ERRSTR"
test -z "$EXEEXT" && exit 1
fi
rm -f $TMPFILE
echo "PASS: $0: $IDN2 example.org"
# Does it handle a simple ASCII string on standard input?
echo example.org | $LOG_VALGRIND $IDN2 > $TMPFILE 2> $TMPFILE-2
rc=$?
OUTSTR="$(cat $TMPFILE | tr -d '\r')"
ERRSTR="$(cat $TMPFILE-2)"
if test $rc != 0; then
echo "FAIL: $0: echo example.org | $IDN2: rc $rc"
echo "OUT: $OUTSTR"
echo "ERR: $ERRSTR"
exit 1
fi
if test "$OUTSTR" != example.org; then
echo "FAIL: $0: echo example.org | $IDN2: expected example.org got $OUTSTR"
echo "OUT: $OUTSTR"
echo "ERR: $ERRSTR"
exit 1
fi
if test "$ERRSTR" != ""; then
echo "FAIL: $0: echo example.org | $IDN2: stderr: $ERRSTR"
echo "OUT: $OUTSTR"
echo "ERR: $ERRSTR"
test -z "$EXEEXT" && exit 1
fi
rm -f $TMPFILE
echo "PASS: $0: echo example.org | $IDN2"
exit 0
|